Subject: Language Bindings SIG

From: "Jack Sanders" <[email-masked]>
Date: Mon, 15 Feb 93 09:57:47 EST

Andy,

My idea of the language binding SIG
is that it would identify the important languages,
would determine how a program written in that language can use the CPI-C
library, and would provide the appropriate documentation for inclusion
in the CPI-C Spec.
For example, the information in the CPI-C Reference - 05, page
58-61, Call Syntax and Programming Language Considerations,
is needed for each language for which a binding is defined.

Some questions to be answered:
  What languages are important?
  What definition of the language is selected? I presume there is a bias
toward standards.  E.g., ANSI COBOL.
  What about such things as "common industry extensions" of standard
languages?  E.g., FORTRAN volatile attribute that enables non-blocking
support in FORTRAN.
  What restrictions on use of CPI-C does a language impose?
  Do we want to continue to define pseudonym files? (I presume: Yes.
Within IBM the pseudonym files were viewed as part of the architecture.)

I am also going to send this to the language binding SIG using the
mail exploder.  So some of you may get this twice.

Jack
-------------------------------------------------------------
Date: 11 Feb 93 14:42:40 EST
From: "Alexander W. Coburn" <[email-masked]>
To: Jack Sanders <[email-masked]>
Cc: Andrew Chandler <[email-masked]>,
        "William R. Greene" <[email-masked]>,
        John Yin <[email-masked]>
Subject: Language Binding SIG

Sorry for the delay, but it's been frantic here. I'm sure you understand.
I still don't have a clear idea of just what this SIG is supposed to do,
but what I would LIKE it to do, is get each of the languages with which we
are dealing, to concur with the design of CPI-C 2.0, in order that we can
have IBM publish the fact that these languages support CPI-C 2.0. We think
that VS COBOL II doesn't like the asynchronous updating of data areas, and
one of the first tasks we have is to verify that this is the problem. If
it is, then, presumably, other languages would (should? could?) have the
same objection. I imagine that, in reality, there would be few problems
that are not common to all languages, and we have to be sure that the
people with whom we speak are truly listening and thinking about the
potential problems.
    Therefore, we have VS COBOL II, for sure, and I have listed below
some other languages with whom we have to communicate. Please add to this
list however you can:
    Application Generator
    C
    VS COBOL II
    FORTRAN
    PL/I
    Procedures Language (REXX)
    RPG
    ADA
We know at least some of the platforms on which these languages run:
   CICS
   IMS
   MVS
   OS/2
   OS/400
   CM
   DOS
   AIX
One of my goals is to understand, if not eliminate, the green printing
on page 58 of the CPI-C Reference (SC26-4399-05 which is CPI-C 1.1). I
have been using VS COBOL II to write APPC/MVS programs and it works fine.
Why is it not allowed? Even on CPI-C 1.1 which has no non-blocking calls?
Why should APPC/MVS support FORTRAN, PL/I, REXX and RPG but not COBOL?

Please send me your thoughts on this direction for the SIG. If I am off
base, say so now, so that we can get on track in time for the March CIW.

Thank you
Andy Coburn
[email-masked]